"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FaTagListRuleEngine = void 0;
const list_1 = __importDefault(require("markdown-it/lib/rules_block/list"));
const MarkdownItEngineBase_1 = require("./MarkdownItEngineBase");
const FaTagListTokenReplacer_1 = require("./FaTagListTokenReplacer");
class FaTagListRuleEngine extends MarkdownItEngineBase_1.MarkdownItEngineBase {
    jack(state, startLine, endLine, silent) {
        const newTokenStart = state.tokens.length;
        const ret = (0, list_1.default)(state, startLine, endLine, silent);
        if (ret) {
            const newTokenEnd = state.tokens.length - 1;
            if (!silent) {
                const replacer = new FaTagListTokenReplacer_1.FaTagListTokenReplacer(state, { start: newTokenStart, end: newTokenEnd });
                replacer.replace();
            }
        }
        return ret;
    }
    use() {
        this._md.block.ruler.at('list', (state, startLine, endLine, silent) => {
            return this.jack(state, startLine, endLine, silent);
        }, { alt: ['paragraph', 'reference', 'blockquote'] });
    }
}
exports.FaTagListRuleEngine = FaTagListRuleEngine;
